.include	"m168def.inc"
.def temp		=r16
.def temp1		=r17
.def counter	=r20
.def 	dataEE	=r20
.def	adrEE 	=r25
.equ array_Uend=$150
.equ array_Iend=$1b0
.def	count	=r24	; GP loop counter
.def	tempf	=r25	; temp for FP lib
.equ beep	=pd0
.equ out_sin=pb2		; PWMout
.equ ui		=pd5		; toggle U-I "0"- U "1"- I
.equ frq	=pd6		; frequency   "0"- 100Hz "1"-1KHz
.equ gain1	=pd7		; stage 1 "0"-Ku=1 "1"-Ku=10
.equ gain2	=pb0		; stage 2 "0"-Ku=1 "1"-Ku=10
.equ g_1	=7			; pin11(pd7)
.equ g_2	=0			; pin12(pb0)
.equ i_1	=1			; pin13(pb1)
.equ leftbut=2			; left button(pin32 pd2)
.equ righbut=3			; right button(pin1 pd3)
.equ reslcd	=pc5		; pin 28(dip) 28(tqfp)
.equ sce   	=pc4 		; pin 27      27
.equ dc    	=pc3 		;     26      26
.equ sdin  	=pc2 		;     25      25
.equ sclk  	=pc1 		;     24      24
.equ i_1_1000=pb1		; pin13
;============RAM=====================
.dseg
.org $100
array_i: .byte 80
array_u: .byte 80
sum_adr: .byte 4
re_i:   .byte 4
re_u:	.byte 4
im_i:	.byte 4
im_u:	.byte 4
re_im:	.byte 4		;Ire^2+Iim^2
IreUre:	.byte 4
IimUim:	.byte 4
IreUim:	.byte 4
UreIim:	.byte 4
R:		.byte 4
jX:		.byte 4
C:		.byte 4
L:		.byte 4
Q:		.byte 4
DF:		.byte 4
RES:	.byte 4		;resistor 100ohm or 1Kohm
flagsRAM:	.byte 1	;flags
pointer:.byte 2		;data pointer for PWM
numper:	.byte 1		;period counter for PWM (initial 5-1KHz,50-100Hz)
freqRAM:.byte 1		;frequency - 5-1KHz,50-100Hz
KuI:	.byte 1		;1, 10 or 100
KuU:	.byte 1
R_:		.byte 2		;100 or 100000
r100:	.byte 1
r1k:	.byte 1
SCREEN:	.byte 84	; RAM for LCD 
;=======FLAGS=============
.equ	meas	=0		;flag start measurings 0-stop, 1-start
.equ	frqncy	=1		;frequency 0-100Hz 1-1KHz
.equ 	ovlADC	=2		;ADC overload 0-!, 1-overloaded
.equ	p_s		=3		;mode 0-parallel, 1-serial
.equ	Ku1		=4		;Ku DA3.1 0-1 1-10
.equ	Ku2		=5		;Ku DA3.2 0-1 1-10
.equ	ResI	=6		;Resistor 0-100 kOhms 1-100 Ohms(for I)
.equ	ResU	=7		;Resistor 0-100 kOhms 1-100 Ohms(for U)

.equ 	k100ee	=00
.equ	k100kee	=01
;=========================
DECBUFF: .byte	15		; some place to hold Decimal Digits
MATHTMP: .byte	8		; Accumulator 'Holding' registers.
;-----------EEPROM-----------------------
;.eseg
;k100ee:		.byte 1			;100ohms (var 90-110)
;k100kee:	.byte 1			;100Kohms(var 90-110)
;flagsEE:	.byte 1			;flags in EEPROM

;********The MAIN Programm*********************
.cseg
.org	$00
  		jmp reset
.org 	$02
		jmp btn_l		;left button(int0)
.org	$04
		jmp btn_r		;right button(int1)
.org OC1Aaddr
		jmp _tim1_ovf
.org OC1Baddr
		jmp t1compare
.cseg
.org $001a
RESET:	ldi	temp,low(RAMEND)
		out	SPL,temp
		ldi	temp,high(RAMEND)
		out	SPH, temp
	;	call wrconst
	;	rcall fltbcd
	;rcall fltbcd
	;rcall mkf
	;	rjmp reset
;-------PORTs init-------------------------------
		ldi temp,(1<<out_sin)+(1<<gain2)+(1<<i_1_1000);pb2-out sin
		out ddrb,temp
		sbi portb,out_sin
		ldi temp,(1<<ui)+(1<<frq)+(1<<gain1)+(1<<beep)
		out ddrd,temp
		sbi portd,frq 						;for 1khz set
		ldi temp,(1<<reslcd)+(1<<sce)+(1<<dc)+(1<<sdin)+(1<<sclk);LCD pins
		out ddrc,temp
		out portc,temp
;-----ADC mode:ADC0-input,Uref=Vcc,right adjust--
		ldi temp,(0<<refs0)
		sts admux,temp
;----------------BUTTONS-------------------------
; Interrupts from buttons (int0 - right, int1 - left)
		ldi temp,(1<<isc11)+(1<<isc01)	;falling edge
		sts eicra,temp
		ldi temp,(1<<int0)+(1<<int1)
		out eimsk,temp						;ints enabled
;===============PWM==============================
;------Use OC1B as output,/OC1b - disconnected---
;----------Timer1 interrupt is enabled-----------
		ldi temp,(1<<ocie1a)+(1<<ocie1b)
		sts timsk1,temp
;-------OC1B(pin14 for TQFP), mode - FastPWM-----
		ldi temp,(1<<com1b1)+(1<<wgm11)+(1<<wgm10)
		sts tccr1a,temp
;---------Load constant to OCR1A  - overflow(set OC1A) 
		clr temp
		ldi temp1,199
		sts ocr1ah,temp
		sts ocr1al,temp1				;100KHz - Fpwm
;-------OCR1B initial value for comparing (clear OC1B)
		ldi temp1,100
		sts ocr1bh,temp
		sts ocr1bl,temp1
;=======================================================
		rcall delay
		rcall eecheck		;if r100 r1k in range(90...110)?
	;	call calcC
	;	rcall KuI_new
	;	rcall KuU_new
		rcall lcdinit
		ldi zl,low(datasin*2+19)		;take the *first sin value
		ldi zh,high(datasin*2+19)
;-------------------------------------------------------	
		sts pointer,zl					;put it to RAM
		sts (pointer+1),zh
;-------------------------------------------------------	
		ldi temp,0b00001010	;start=0-> not to start!F=1Khz,KuI=1 
		sts flagsRAM,temp	;KuU=1 Res=100kOhms, Normal mode, Serial
;-------------------------------------------------------	
		ldi temp,5
		sts numper,temp
		sts freqRAM,temp				;load 1KHz
;-------------------------------------------------------	
		ldi temp,(1<<cs10)+(1<<wgm12)+(1<<wgm13)
		sts tccr1b,temp			; T=PCK, start PWM!
;------------------------------
		sei								;ints enabled
;-------------------------------------------------------

;-----------GET DATA------
main:	cbi portd,beep
		cbi portd,ui			;U - 0
		rcall delay1
		rcall setko				;tune Ku for U	
		rcall calcKu			;calculate Ku
		sts KuU,temp			;save Ku for U
;-------move flag RES for U-mode-------
		lds temp,flagsRAM
		bst temp,ResI
		bld temp,ResU
		sts flagsRAM,temp
;--------------------------------------
		ldi counter,40			;40 periods...
		rcall getarray
		rcall remove			;remove it to array_U
		cbi portb,i_1			;min gain..
		cbi portd,g_1
		cbi portb,g_2
;-----------now we have U in $160-$1b0 (40 words)-------
		sbi portd,ui
		rcall delay1
		rcall setko				;tune Ku for I	
		rcall calcKu
		sts KuI,temp			;save Ki for I and flag RESISTOR
		ldi counter,40			;40 periods...
		rcall getarray			;get I-array ($100-$150)
;--------------------------------------------------------
		cbi portb,i_1			;min gain..
		cbi portd,g_1
		cbi portb,g_2
	;	rjmp main
	;	rcall EE_U
	;	rcall EE_I
mn:	;	rjmp main
	rcall getReIm	;ReIm in RAM
	rcall calcR
	rcall calcX
	rcall calcC
	rcall calcL
	rcall calcDF
	rcall calcQ
ff:	rcall fillscr
	rcall zero_remove
	rcall lcdout
main1:	rjmp	main
;--------fill array with data *x-------------
getarray:
		ldi xl,low(array_i)	;XH-XL - start array address
		ldi xh,high(array_i)
		rcall arr_clr				;clearing ArrayI *x
		ldi xl,low(array_i)			;XH-XL - start array adress
		ldi xh,high(array_i)
		clr r4
		clr r5
		lds temp,freqRAM
		sts numper,temp				;5 periods for 1kHz(or 50 for 100Hz) in 1 step
;		sbi portd,beep				;just for control...
wait_max:		lds zl,pointer		;load pointer from RAM
		lds zh,pointer+1
		lpm							;is it sinus start?
		mov temp,r0
		cpi r16,135					;135-max  amplitude (from table)
		brne wait_max				;waiting for start...
		clr temp					;it begins...
		sts tcnt1h,temp
		sts tcnt1l,temp				;clr timer
		lds temp,flagsRAM
		ori temp,$01				;start=1 -> start!
		sts flagsRAM,temp
;		cbi portd,beep
ll:		lds temp,flagsRAM
		sbrc temp,meas				;skip if flag=0 (array is filled!)
		rjmp ll
		ret	
;---------------------------------------------
setko:	cbi portb,i_1			;min gain..
		cbi portd,g_1
		cbi portb,g_2
		lds temp,flagsRAM
		andi temp,0b10001111	;reset flags for KuI
		sts flagsRAM,temp
		rcall delay1			;20mS delay
;-----------------------------------------------------
setk:	rcall getmax			;max - r10-r11
		ldi temp,high(1020*2)
		ldi temp1,low(1020*2)
		sub temp1,r11
		sbc temp,r10			;(1020-Umax)
		brcs ovload				;if max>1020->overload
		ldi temp,high(561*2)		;about 1.37V (ampl. 0.12V)
		ldi temp1,low(561*2)		;
		sub temp1,r11
		sbc temp,r10			;(561-Umax)(if C=1,then OK!)
		brcc notgood
		rjmp b_good
;------------------------------------------------------
notgood:sbic pind,g_1			;gain1=1?
		rjmp g2					;yes, to gain2
		sbi portd,g_1			;no,set it	******* x10
		lds temp,flagsRAM
		ori temp,0b00010000		;and set flag Ku1
		sts flagsRAM,temp
		rcall delay1
		rjmp setk				;ang get new array
g2:		sbic pinb,g_2			;gain2=1?
		rjmp g3					;yes, look i_1_1000
		sbi portb,g_2			;no,set gain2****** x100
		lds temp,flagsRAM
		ori temp,0b00100000		;and set flag Ku2
		sts flagsRAM,temp
		rcall delay1
		rjmp setk				;and get new array
g3:		sbic pinb,i_1			;if 100 KOhm, turn on 100 ohms and repeat
		rjmp less_min
		sbi portb,i_1			;turn on 100ohms
		cbi portb,g_2			;and Ku=1
		cbi portd,g_1			;******************x1000
		lds temp,flagsRAM
		ori temp, 0b01000000		;set flags RES (100ohms) Ku1-1 Ku2-1
		andi temp,0b11001111
		sts flagsRAM,temp
		rcall delay1
		rjmp setk
ovload:	cbi portb,i_1			;min gain
		cbi portd,g_1
		cbi portb,g_2
		lds temp,flagsRAM
		andi temp,0b10001111		;set flags (min gain)
		ori temp,0b00000100			;set flag ADC overload
		sts flagsRAM,temp
		rcall delay1
		rjmp b_good
less_min:
		sbi portb,i_1			;max gain, flags and get out...
		sbi portd,g_1
		sbi portb,g_2
		lds temp,flagsRAM
		ori temp,0b01110000		;set flags (max gain)
		sts flagsRAM,temp
b_good:	ret
;*********procedure for getting max value in array******
getmax:	ldi counter,2				;2 periods...
		rcall getarray
;--------we got 2 periods in array_i-------------------
;--------and looking for max value...------------------------
		ldi xl,low(array_i)		;XH-XL - start array adress
		ldi xh,high(array_i)
;---------------------
		ldi count,39
		ld temp,x+
		ld temp1,x+				;get current value
		mov r10,temp
		mov r11,temp1			;copy it->r10-r11
;---------------------
find:	cpi count,0
		breq cmp_max			;all? yes, we get max
		ld r8,x+
		ld r19,x+				;get next value 
		sub temp1,r19
		sbc temp,r8				;(cur-next)>0->C=0
		brcc takenext			;C=1(cur<next)
		mov temp,r8				;curr<-next
		mov temp1,r19
		mov r10,temp
		mov r11,temp1			;copy it->r10-r11
		dec count			
		rjmp find
takenext:
		mov r16,r10
		mov r17,r11
		dec count
		rjmp find			;here get max in r10-r11
cmp_max:ret
;***********************************************
calcKu: lds temp,flagsRAM
		andi temp,0b00110000	;check only Ku1 Ku2
		lsr temp
		lsr temp
		lsr temp	;here we get xxxxxbbb flags
		lsr temp
		cpi temp,0
		brne ch10	;not 1? check 10
		ldi temp,1
		rjmp ch_over;OK, Ku=1
ch10:	cpi temp,1
		brne ch10_
k_10:	ldi temp,10
		rjmp ch_over; Ku=10
ch10_:	cpi temp,2
		brne ch100
		rjmp k_10	;if k=3,Ku=10
ch100:	ldi temp,100; Ku=100
ch_over:ret			;here in temp - Ku
;----------fill arrayU with $00 from *x--------
arr_clr:push temp
		push counter
		ldi counter,80				;80 bytes clear
		clr temp
not_all:st x+,temp
		dec counter
		brne not_all
		pop counter
		pop temp
		ret
;--------------
remove:	ldi counter,80
		ldi xl,low(array_i)	;XH-XL - start array adress
		ldi xh,high(array_i)
		ldi yl,low(array_u)	;XH-XL - start array adress
		ldi yh,high(array_u)
not_a:	ld temp,x+
		st y+,temp
		dec counter
		brne not_a
		ret
fillscr:
;------1st line---------
	ldi xl,low(screen)
	ldi xh,high(screen)
	lds temp,flagsRAM
	sbrc temp,p_s
	rjmp s_mode
	ldi zl,low(pmode*2)		;parallel mode
	ldi zh,high(pmode*2)
	rjmp shfrq
s_mode:ldi zl,low(smode*2)	;serial mode
	ldi zh,high(smode*2)
shfrq:
	rcall flmode			;load to screen RAM mode
	lds temp,flagsRAM
	sbrc temp,frqncy		;bit1=0 ->100Hz 1->1KHz
	rjmp out1K
	ldi zl,low(fr100*2)		;load "100Hz"
	ldi zh,high(fr100*2)
	rjmp outfr
out1K:	ldi zl,low(fr1K*2)	;load "1KHz"
	ldi zh,high(fr1K*2)
outfr:	rcall flfreq			;load to screen RAM freq
	ldi zl,low(blnk*2)
	ldi zh,high(blnk*2)
	rcall flstring				;load to screen RAM line2
;---3rd line----------	
	ldi xl,low(screen+28)
	ldi xh,high(screen+28)
	ldi zl,low(R)
	ldi zh,high(R)
	rcall fllR
	ldi zl,low(jX)
	ldi zh,high(jX)
	rcall flljX
	ldi zl,low(jX)
	ldi zh,high(jX)
	rcall ld_z			
	rcall fltbcd
	lds temp,flagsRAM
	sbrs temp,p_s
	jmp go_L
	sbrc r5,7	;serial mode "-" - C!
	rjmp showC
	jmp goL
go_L:	sbrs r5,7;parallel mode "+"-C!
	rjmp showC
goL:	ldi zl,low(L)
	ldi zh,high(L)
	rcall fllL
	ldi zl,low(Q)
	ldi zh,high(Q)
	rcall fllQ
	rjmp show_over
showC:	ldi zl,low(C)
	ldi zh,high(C)
	rcall fllC
	ldi zl,low(DF)
	ldi zh,high(DF)
	rcall fllDF
show_over:	ret

zero_remove:
	ldi	yl,low(screen+28+4)
	ldi	yh,high(screen+28+4)
	ldi counter,4	;4 lines
ts0:ld temp,y		;get 1st "0"
	cpi temp,$30
	brne nxt0		;if not, don't test next!
	ldi temp,' '	;if 0,blank it and check next...
	st y,temp
	adiw y,1
	ld temp,y
	cpi temp,$30
	brne nxt1
	ldi temp,' '
	st y,temp
	rjmp nxt1
nxt0:
	adiw y,1
nxt1:	adiw y,13
	dec counter
	brne ts0
	ret
;-------------------------------
fllR:
	ldi	yl,low(DECBUFF)
	ldi	yh,high(DECBUFF)
	ldi	tempf,' '	;     " "
	st	y+,tempf
	lds temp,flagsRAM
	sbrc temp,p_s
	jmp ldr
	ldi tempf,'G'	;load "G"
	jmp ldg
ldr:ldi	tempf,'R'	;load "R"
ldg:st	y+,tempf
	ldi	tempf,'='	;     "="
	st	y+,tempf
	ldi	tempf,' '	;     " "
	st	y+,tempf
	rcall ld_z			
	rcall fltbcd

	lds temp,flagsRAM
	sbrs temp,p_s
	jmp ldY

	rcall KMohm
	rcall itoa
	st y+,temp		;load k,M or space 
	ldi tempf,$7C	;omega
	st y+,tempf
	ldi tempf,' '
	st y+,tempf
	st y+,tempf	
	jmp zy
	;---------------
ldY:rcall mkf
	mov tempf,r12
	cpi tempf,$83	;if order -3 without .
	brne pnt_		
	rcall itoa1		;output without point
	rjmp pnt1_
pnt_:cpi tempf,$82	;or if -2
	brne w_pnt_
	sbrc tempf,7
	jmp w_pnt_
	rcall itoa1		;the same...
	rjmp pnt1_
w_pnt_:
	rcall itoa
pnt1_:	st y+,temp	;load mju,n,p...or space (
	ldi tempf,'C';	;Farad
	st y+,tempf
	ldi tempf,'m'
	st y+,tempf
	ldi tempf,' '
	st y+,tempf
zy:	rcall loadbuf
	ret
;-------------------------------
flljX:
	ldi	yl,low(DECBUFF)
	ldi	yh,high(DECBUFF)
	ldi	tempf,'j'	;     "j"
	st	y+,tempf
	lds temp,flagsRAM
	sbrc temp,p_s
	jmp ldx
	ldi tempf,'B'	;load"B"
	jmp ldb
ldx:ldi	tempf,'X'	;load "X"
ldb:st	y+,tempf
	ldi	tempf,'='	;     "="
	st	y+,tempf
	rcall ld_z			
	rcall fltbcd
	mov tempf,r5
;--------------------
	sbrc tempf,7		;look at sign
	rjmp minus
	ldi tempf,' '
	rjmp plus
minus:	ldi tempf,'-'
plus:	st	y+,tempf	;load sign
;--------------------

	lds temp,flagsRAM
	sbrs temp,p_s
	jmp ldsm		;out ->Siemens

	rcall KMohm		;else Ohms
	rcall itoa
	st y+,temp		;load k,M or space 
	ldi tempf,$7C	;omega
	st y+,tempf
	ldi tempf,' '
	st y+,tempf
	st y+,tempf	
	jmp yz
ldsm:
	rcall mkf		;display them like C
	mov tempf,r12
	cpi tempf,$83	;if order -3 without .
	brne pnt__		
	rcall itoa1		;output without point
	rjmp pnt1__
pnt__:cpi tempf,$82	;or if -2
	brne w_pnt__
	rcall itoa1		;the same...
	rjmp pnt1__
w_pnt__:
	rcall itoa
pnt1__:	st y+,temp	;load mju,n,p...or space 
	ldi tempf,'C';	;Siemens
	st y+,tempf
	ldi tempf,'m'
	st y+,tempf
	ldi tempf,' '
	st y+,tempf
yz:	rcall loadbuf
	ret
;---------------------------------------
fllC:
	ldi	yl,low(DECBUFF)
	ldi	yh,high(DECBUFF)
	ldi	tempf,' '	;     " "
	st	y+,tempf
	ldi	tempf,'C'	;load "C"
	st	y+,tempf
	ldi	tempf,'='	;     "="
	st	y+,tempf
	ldi	tempf,' '	;     " "
	st	y+,tempf
	rcall ld_z			
	rcall fltbcd
	rcall mkf
	mov tempf,r12
	cpi tempf,$83	;if order -3 without .
	brne pnt		
	rcall itoa1		;output without point
	rjmp pnt1
pnt:cpi tempf,$82	;or if -2
	brne w_pnt
	rcall itoa1		;the same...
	rjmp pnt1
w_pnt:
	rcall itoa
pnt1:	st y+,temp	;load mju,n,p...or space (
	ldi tempf,'F';	;Farad
	st y+,tempf
	ldi tempf,' '
	st y+,tempf
	st y+,tempf	
	rcall loadbuf
	ret

fllL:
	ldi	yl,low(DECBUFF)
	ldi	yh,high(DECBUFF)
	ldi	tempf,' '	;     " "
	st	y+,tempf
	ldi	tempf,'L'	;load "L"
	st	y+,tempf
	ldi	tempf,'='	;     "="
	st	y+,tempf
	ldi	tempf,' '	;     " "
	st	y+,tempf
	rcall ld_z			
	rcall fltbcd
	rcall mkf
	mov tempf,r12
	cpi tempf,$83	;if order -3 without .
	brne pnt2		
	rcall itoa1		;output without point
	rjmp pnt3
pnt2:cpi tempf,$82	;or if -2
	brne w_pnt1
	rcall itoa1		;the same...
	rjmp pnt3
w_pnt1:
	rcall itoa
pnt3:	st y+,temp	;load mju,n,p...or space 
	ldi tempf,'H'	;Henry
	st y+,tempf
	ldi tempf,' '
	st y+,tempf
	st y+,tempf	
	rcall loadbuf
	ret
fllDF:
	ldi	yl,low(DECBUFF)
	ldi	yh,high(DECBUFF)
	ldi	tempf,'D'	;     "D"
	st	y+,tempf
	ldi	tempf,'F'	;load "F"
	st	y+,tempf
	ldi	tempf,'='	;     "="
	st	y+,tempf
	ldi	tempf,' '	;     " "
	st	y+,tempf
	rcall ld_z			
	rcall fltbcd
	rcall Q_DF
	rcall itoa2
	ldi tempf,' '
	st y+,tempf
	st y+,tempf
	st y+,tempf	
	rcall loadbuf
	ret
fllQ:
	ldi	yl,low(DECBUFF)
	ldi	yh,high(DECBUFF)
	ldi	tempf,' '	;     " "
	st	y+,tempf
	ldi	tempf,'Q'	;load "F"
	st	y+,tempf
	ldi	tempf,'='	;     "="
	st	y+,tempf
	ldi	tempf,' '	;     " "
	st	y+,tempf
	rcall ld_z			
	rcall fltbcd
	rcall Q_DF
	rcall itoa2
	ldi tempf,' '
	st y+,tempf
	st y+,tempf
	st y+,tempf	
	rcall loadbuf
	ret
;----line loading------------
loadbuf:	ldi zl,low(decbuff)
	ldi zh,high(decbuff)
	ldi temp,14			;14 symbols by line
nextnum:	ld temp1,z+
	st x+,temp1
	dec temp
	brne nextnum
	ret
;----------------------
;    mode - 9 symbols
flmode:
	ldi temp,9
nexsym:
	lpm
	mov temp1,r0
	adiw z,1
	st x+,temp1
	dec temp
	brne nexsym
	ret
;-----show freq (5 symbols)-----------------
flfreq:
	ldi temp,5
nextsym:
	lpm
	mov temp1,r0
	adiw z,1
	st x+,temp1
	dec temp
	brne nextsym
	ret
;-------------------
flstring:
	ldi temp,14
nextsm:
	lpm
	mov temp1,r0
	adiw z,1
	st x+,temp1
	dec temp
	brne nextsm
	ret

;----for R xxx.xx Ohm, kOhm, MOhm-------------
KMohm:
	mov temp,r5
	andi temp,0b01111111
	mov r5,temp			;"-"->+!	
	mov temp,r12		;exp->temp
	sbrs temp,7			;if exp>0,skip
	rjmp posi
	andi temp,0b01111111		;make exp"+"
	ldi temp1,2
	add temp,temp1
	neg temp
	rjmp les0
posi:ldi temp1,3			;order3 - kohms
	cp temp,temp1
	brge kom
	dec temp
	dec temp
les0:rcall shifts		;shift our numbers...
	ldi temp,' '		;space->temp
	rjmp sh_ok
kom:ldi temp1,6			;order>6 - Mohms
	cp temp,temp1
	brge mom
	ldi temp1,-5
	add temp,temp1
	rcall shifts
	ldi temp,'k'		;"k"->temp
	rjmp sh_ok
mom:ldi temp1,-8
	add temp,temp1
	rcall shifts
	ldi temp,'M'		;"M"->temp
sh_ok:	ret				;in temp - symbol code!!!!r5-r6-r7-data
;-----------------------------
shifts:cpi temp,0
	breq gogo
	cpi temp,$80
	breq gogo
ddd:ldi temp1,4
dd_:lsr r5
	ror r6
	ror r7
	ror r8
	dec temp1
	brne dd_
	inc temp
	cpi temp,0
	brne ddd
gogo:	ret

;----for C xxx.xx pF, nF, uF-------------
	
mkf:mov temp,r5
	andi temp,0b01111111
	mov r5,temp	
	mov temp,r12		;exp->temp
	sbrs temp,7			;if exp<0 skip
	jmp posi			;and THERE return!
	andi temp,0b01111111		;make"+"
	ldi temp1,1			;0.99-9.99F
	cp temp1,temp
	brlo mkf_big
	ldi temp1,2
	add temp,temp1
	neg temp
	rcall shifts		;shift our numbers...
	ldi temp,' '		;space->temp
	rjmp sh_ok1
mkf_big:
	ldi temp1,4			;10000-99999mkF
	cp temp,temp1
	brge mkf_
	ldi temp1,0
	add temp,temp1
	neg temp
	rcall shifts
	ldi temp,$7b;		;"mju"->temp
	rjmp sh_ok1			;here dont forget delete "."!!!
mkf_:ldi temp1,8			;order >-8 - nF
	cp temp,temp1
	brge nf
	ldi temp1,-4
	add temp,temp1
	neg temp
	rcall shifts
	ldi temp,$7b;		;"mju"->temp
	rjmp sh_ok1
nf: ldi temp1,10		;order < -10
	cp temp,temp1
	brge pf
	ldi temp1,-7
	add temp,temp1
	neg temp
	rcall shifts
	ldi temp,'n'		;"n"->temp
	rjmp sh_ok1
pf:	ldi temp1,-10
	add temp,temp1
	neg temp
	rcall shifts
	ldi temp,'p'
sh_ok1:	ret		


Q_DF:
;----for Q&DF xxxx.xxxx-------------
	mov temp,r5
	andi temp,0b01111111
	mov r5,temp	
	mov temp,r12		;exp->temp
	sbrc temp,7
	rjmp exp_p
	ldi temp1,-2
	add temp,temp1
	rjmp shfts
exp_p:
	andi temp,0b01111111
	ldi temp1,2
	add temp,temp1
	neg temp
shfts:	rcall shifts		;shift our numbers...
	ldi temp,' '		;space->temp
	rjmp sh_ok2
sh_ok2:	ret	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
getReIm:
;SUM=SUM(i=0 to 39)[v(i)*cos(i)]
;------get sum for RE_I----------
	rcall clr_sum
	ldi r24,2
	mov r8,r24		;R24-period counter(2 periods-40 points)
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par1
	;---------------------------------
	ldi xl,low(array_i)		;for serial
	ldi xh,high(array_i)
	rjmp yy2
	;---------------------------------
par1:ldi xl,low(array_u)	;for parallel
	ldi xh,high(array_u)
	;---------------------------------
yy2:ldi	zl,low(t0*2)
	ldi	zh,high(t0*2)
	ldi r24,11		;11 - i0...i10 (1st 1/2 period)
yy:	rcall getsum_up
	dec r24			;dec counter
	brne yy			;all?
	sbiw z,5		;return to previous...
	ldi r24,9		;9 - i11...i19 (2nd 1/2 period)
yy1:rcall getsum_down
	dec r24			;dec counter
	brne yy1		;all?
	dec r8
	brne yy2		;all periods?
;---------------------------------
	rcall KuI_new	;KuI*res->acc1
	rcall sum_ac1	;ReI->acc1 KuI*res->acc2
	rcall fdiv		;ReI/(KuI*res)->acc1
	sts re_i,r13
	sts re_i+1,r14
	sts re_i+2,r15
	sts re_i+3,r16
;------get sum for RE_U-----------
	rcall clr_sum
	ldi r24,2
	mov r8,r24		;period counter(2 periods-40 points)
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par2
	;-----------------------------------
	ldi xl,low(array_u)	;for serial mode
	ldi xh,high(array_u)
	rjmp yy3
	;-----------------------------------
par2:ldi xl,low(array_i);for parallel mode
	ldi xh,high(array_i)
	;-----------------------------------
yy3:ldi	zl,low(t0*2)
	ldi	zh,high(t0*2)
	ldi r24,11		;11 - i0...i10 (1/2 period)
yy4:rcall getsum_up
	dec r24			;dec counter
	brne yy4		;all?
	sbiw z,5		;return to previous...
	ldi r24,9		;9 - i11...i19 (1/2 period)
yy5:rcall getsum_down
	dec r24			;dec counter
	brne yy5		;all?
	dec r8
	brne yy3		;all periods?
;-------------------------------
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par5
;-----for serial mode-----------
	rcall KuU_new	;load KuUnew->ac1
	lds r13,KuU
	rcall clracc	;load Ku->acc1
	rcall itof		;convert to float(in acc1)	
	rcall f_mul		;Ku*Ku_new->acc1
	rcall AC1TOAC2	;to acc2
	rcall sum_ac1	;load ReU->acc1 Ku->acc2
	rcall fdiv		;(ReU/KuU)-acc1
	jmp ssum1
;-----for parallel mode-(/Ki)--------
par5:
	rcall KuI_new	;KuI*res->acc2
	rcall sum_ac1	;ImI->acc1 KuI*res->acc2
	rcall fdiv		;ImI/(KuI*res)->acc1
;----save sum to RAM (re_u)-------
ssum1:sts re_u,r13
	sts re_u+1,r14
	sts re_u+2,r15
	sts re_u+3,r16
;------get sum for IM_I-----------
	rcall clr_sum
	ldi r24,2
	mov r8,r24		;period counter(2 periods-40 points)
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par3
	;-------------------------------
	ldi xl,low(array_i)		;serial
	ldi xh,high(array_i)
	rjmp yy6
	;-------------------------------
par3:ldi xl,low(array_u)	;parallel
	ldi xh,high(array_u)
	;-------------------------------
yy6:ldi	zl,low(t5*2)	;sin(0)=0!
	ldi	zh,high(t5*2)
	ldi r24,6		;6 - i0...i5 (1/2 period)
yy7:rcall getsum_up
	dec r24			;dec counter
	brne yy7		;all?
	sbiw z,5		;return to previous...
	ldi r24,10		;10 - i6...i15 (1/2 period)
yy8:rcall getsum_down
	dec r24			;dec counter
	brne yy8		;all?
	adiw z,5		;return to previous...
	ldi r24,4		;4 - i16...i19 (1/2 period)
yy9:rcall getsum_up
	dec r24			;dec counter
	brne yy9		;all?
	dec r8
	brne yy6		;all periods?
;---------------------------------
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par6
;------for serial mode------------
	rcall KuI_new	;KuI*res->acc2
	rcall sum_ac1	;ImI->acc1 KuI*res->acc2
	rcall fdiv		;ImI/(KuI*res)->acc1
	jmp ssum2
;-----for parallel mode-(/Ki)--------
par6:
	rcall KuU_new	;load KuUnew->ac1
	lds r13,KuU
	rcall clracc	;load Ku->acc1
	rcall itof		;convert to float(in acc1)	
	rcall f_mul		;Ku*Ku_new->acc1
	rcall AC1TOAC2	;to acc2
	rcall sum_ac1	;load ReU->acc1 Ku->acc2
	rcall fdiv		;(ReU/KuU)-acc1
;---------------------------------
ssum2:	sts im_i,r13
	sts im_i+1,r14
	sts im_i+2,r15
	sts im_i+3,r16
;------get sum for IM_U-----------
	rcall clr_sum
	ldi r24,2
	mov r8,r24		;r8-period counter(2 periods-40 points)
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par4
	;--------------------------------
	ldi xl,low(array_u)		;serial
	ldi xh,high(array_u)
	rjmp yy10
	;--------------------------------
par4:ldi xl,low(array_i)	;parallel
	ldi xh,high(array_i)
	;--------------------------------
yy10:ldi zl,low(t5*2)
	ldi	zh,high(t5*2)
	ldi r24,6		;6 - i0...i5 
yy11:rcall getsum_up
	dec r24			;dec counter
	brne yy11		;all?
	sbiw z,5		;return to previous...
	ldi r24,10		;10 - i6...i15 
yy12:rcall getsum_down
	dec r24			;dec counter
	brne yy12		;all?
	adiw z,5		; 
	ldi r24,4		;4 - i16...i19 
yy13:rcall getsum_up
	dec r24			;dec counter
	brne yy13		;all?
	dec r8
	brne yy10		;all periods?
;---------------------------------
	lds temp,flagsRAM
	sbrs temp,p_s	;if serial mode,skip
	jmp par7
;-----for serial mode-------------
	rcall KuU_new	;load KuUnew->ac1
	lds r13,KuU
	rcall clracc	;load Ku->acc1
	rcall itof		;convert to float(in acc1)	
	rcall f_mul		;Ku*Ku_new->acc1
	rcall AC1TOAC2	;to acc2
	rcall sum_ac1	;load ImU->acc1 Ku->acc2
	rcall fdiv		;(ImU/KuU)-acc1
	jmp ssum3
;-----for parallel mode-----------
par7:
	rcall KuI_new	;KuI*res->acc2
	rcall sum_ac1	;ImI->acc1 KuI*res->acc2
	rcall fdiv		;ImI/(KuI*res)->acc1
;----save sum to RAM (im_u)-------
ssum3:	sts im_u,r13
	sts im_u+1,r14
	sts im_u+2,r15
	sts im_u+3,r16
;***********************************************
;----calculate Ire^2+Iim^2--------
	ldi zl,low(re_i)
	ldi zh,high(re_i)
	rcall ld_z
	rcall AC1TOAC2
	rcall f_mul		;here Ire^2 in ac1
	rcall st_sum	;put it to sum
	ldi zl,low(im_i)
	ldi zh,high(im_i)
	rcall ld_z
	rcall AC1TOAC2
	rcall f_mul		;here Iim^2 in ac1
	rcall ld_sum	;Ire^2 from RAM to acc2
	rcall fadd		;acc1 - needed sum
	sts re_im,r13	;save it to re_im(RAM)
	sts re_im+1,r14
	sts re_im+2,r15
	sts re_im+3,r16
;----calc Ire*Ure---------------
	ldi zl,low(re_i)
	ldi zh,high(re_i)
	rcall ld_z
	rcall AC1TOAC2	;Ire-acc2
	ldi zl,low(re_u)
	ldi zh,high(re_u)
	rcall ld_z		;Ure-acc1
	rcall f_mul		;here Ire*Ure in ac1
	sts IreUre,r13	;save it to IreUre(RAM)
	sts IreUre+1,r14
	sts IreUre+2,r15
	sts IreUre+3,r16
;----calc Iim*Uim---------------
	ldi zl,low(im_i)
	ldi zh,high(im_i)
	rcall ld_z
	rcall AC1TOAC2	;Iim-acc2
	ldi zl,low(im_u)
	ldi zh,high(im_u)
	rcall ld_z		;Uim-acc1
	rcall f_mul		;here Iim*Uim in ac1
	sts IimUim,r13	;save it to IimUim(RAM)
	sts IimUim+1,r14
	sts IimUim+2,r15
	sts IimUim+3,r16
;----calc Ire*Uim---------------
	ldi zl,low(re_i)
	ldi zh,high(re_i)
	rcall ld_z
	rcall AC1TOAC2	;Ire-acc2
	ldi zl,low(im_u)
	ldi zh,high(im_u)
	rcall ld_z		;Uim-acc1
	rcall f_mul		;here Ire*Uim in ac1
	sts IreUim,r13	;save it to IreUim(RAM)
	sts IreUim+1,r14
	sts IreUim+2,r15
	sts IreUim+3,r16
;----calc Ure*Iim---------------
	ldi zl,low(re_u)
	ldi zh,high(re_u)
	rcall ld_z
	rcall AC1TOAC2	;Ure-acc2
	ldi zl,low(im_i)
	ldi zh,high(im_i)
	rcall ld_z		;Iim-acc1
	rcall f_mul		;here Ure*Iim in ac1
	sts UreIim,r13	;save it to UreIim(RAM)
	sts UreIim+1,r14
	sts UreIim+2,r15
	sts UreIim+3,r16
	ret
;--------calc KuI=KuI*res---------
KuI_New:
	lds temp,flagsRAM
	sbrs temp,ResI;RESI	;if 100ohms, skip next
	rjmp res1000
	lds temp,r100
	mov r13,temp		;r13-r14 - const1 (res 100 ohms)
	rcall clracc
	clr r14
	clr temp
	rcall itof			;AC1-const1
	rjmp svr
res1000:
	lds temp,r1k		;r13-r14 - const2 (100KOhms)
	mov r13,temp
	rcall clracc
	clr r14
	clr temp
	rcall itof		; AC1-const2(float)
	ldi	zl,low(k1000*2)	
	ldi	zh,high(k1000*2)
	rcall KTOAC2		;1000 - AC2
	rcall f_mul			;const2*1000(float) - AC1
svr:rcall AC1TOAC2	;move it to acc2
	lds r13,KuI
	rcall clracc
	rcall itof		;KuI(float)-acc1	
	rcall f_mul		;KuI*res-acc1
	rcall AC1TOAC2	;->acc2
	ret
;------------------------------------
KuU_new:
	lds temp,flagsRAM
	sbrs temp,ResU		;if 100ohms, skip next
	rjmp res100k
	lds temp,r1k		;r13-r14 - const2 (100KOhms)
	mov r13,temp
	rcall clracc
	clr r14
	clr temp
	rcall itof		; AC1-const2(float)
	ldi	zl,low(k1000*2)	
	ldi	zh,high(k1000*2)
	rcall KTOAC2		;1000 - AC2
	rcall f_mul			;AC1-const2*1000
	rcall AC1TOAC2		; to AC2		
	lds temp,r100
	mov r13,temp
	rcall clracc
	clr r14
	clr temp
	rcall itof			;R 100ohms(fl)->acc1
	rcall swapacc
	rcall fdiv		;acc1<-100000/R
	rjmp KUok
res100k:			;if 100k - ret(Ku_new=1!!!)
	rcall clracc	;clr acc1
	clr temp
	mov r13,temp
	mov r14,temp
	ldi temp,$80;
	mov r15,temp
	ldi temp,$3f	;1(fl)->acc1
KUok:	rcall AC1TOAC2	;to acc2
	ret
;---------------------------------
clracc:	clr r14
	clr r15
	clr r16
	clr r17
	clr r23
	ret
;**************************************************
;* calc R=Zre=[(Ure*Ire)+(Uim*Iim)]/(Ire^2+Iim^2) *
;**************************************************
calcR:	ldi zl,low(IimUim)
	ldi zh,high(IimUim)
	rcall ld_z		;Iim*Uim-acc1
	rcall AC1TOAC2	;Iim*Uim->acc2
	ldi zl,low(IreUre)
	ldi zh,high(IreUre)
	rcall ld_z		;Ire*Ure->acc1
	rcall fadd		;acc1<-(Iim*Uim+Ire*Ure)
	rcall AC1TOAC2	;remove it to acc2
	ldi zl,low(re_im)
	ldi zh,high(re_im)
	rcall ld_z		;acc1= (Ire^2+Iim^2)
	rcall swapacc	;******************
	rcall fdiv		;here get Z(re)=R *
	sts R,r13		;******************
	sts R+1,r14		;save R to RAM
	sts R+2,r15
	sts R+3,r16
	ret
;***************************************************
;* calc jX=Zim=[(Ire*Uim)-(Ure*Iim)]/(Ire^2+Iim^2) *
;***************************************************
calcX:
	ldi zl,low(IreUim)
	ldi zh,high(IreUim)
	rcall ld_z		;IreUim-acc1
	rcall AC1TOAC2	;IreUim->acc2
	ldi zl,low(UreIim)
	ldi zh,high(UreIim)
	rcall ld_z		;UreIim->acc1
	rcall swapacc	;IreUim-acc1 UreIim->acc2
	rcall fsub		;acc1<-(IreUim-UreIim)
	rcall AC1TOAC2	;remove it to acc2
	ldi zl,low(re_im)
	ldi zh,high(re_im)
	rcall ld_z		;acc1= (Ire^2+Iim^2)
	rcall swapacc	;********************
	rcall fdiv		;*here get Z(im)=jX *
	sts jX,r13		;********************
	sts jX+1,r14		;save jX to RAM
	sts jX+2,r15
	sts jX+3,r16
	ret
;----------------------------------------
;  now we get Z=R+jX in R jX
;----------------------------------------
;************************************
;* --calc C=1/(2*PI*F*jX)---------- *
;************************************
calcC:
;----look at freq flag-------------------
	lds temp,flagsRAM
	sbrc temp,frqncy		;bit1=0 ->100Hz 1->1KHz
	rjmp f_1khz 
	ldi	zl,low(_2pf100*2)	;for 100hz
	ldi	zh,high(_2pf100*2)
	rjmp f_100
f_1khz:
	ldi	zl,low(_2pf1000*2)	;for 1Khz
	ldi	zh,high(_2pf1000*2)
;----------------------------------------
f_100:
	rcall KTOAC2	;2*pi*f-acc2
	ldi zl,low(jX)
	ldi zh,high(jX)
	rcall ld_z		;jX-acc1
	lds r24,flagsRAM
	sbrc r24,p_s
	jmp serC
	call fdiv
	jmp Cout

serC:	rcall f_mul		;acc1<-2*pi*f*X
	rcall swapacc	;acc2<-2*pi*f*X
	ldi	zl,low(K1*2)
	ldi	zh,high(K1*2)
	rcall KTOAC1	;1-acc1
	rcall fdiv		;C->acc1<-1/(2*PI*F*jX)
Cout:	sts C,r13		
	sts C+1,r14		;save C to RAM
	sts C+2,r15
	sts C+3,r16
	ret
;*********************************
;* -- calc L=jX/(2*PI*F) -       *
;*********************************
calcL:
	lds temp,flagsRAM
	sbrc temp,frqncy		;bit1=0 ->100Hz 1->1KHz
	rjmp f1khz 
	ldi	zl,low(_2pf100*2)	;for 100hz
	ldi	zh,high(_2pf100*2)
	rjmp f100
f1khz:
	ldi	zl,low(_2pf1000*2)	;for 1Khz
	ldi	zh,high(_2pf1000*2)
;----------------------------------------
f100:
	rcall KTOAC2	;2*pi*f100-acc2
	ldi zl,low(jX)
	ldi zh,high(jX)
	rcall ld_z		;jX-acc1

	lds r24,flagsRAM;here look at mode.
	sbrc r24,p_s
	jmp serL		;serial mode
	
	rcall f_mul		;acc1<-2*pi*f*L
	rcall swapacc	;acc2<-2*pi*f*L
	ldi	zl,low(K1*2)
	ldi	zh,high(K1*2)
	rcall KTOAC1	;1-acc1

serL:rcall fdiv		;L->acc1<-1/(2*PI*F*L)	
	sts L,r13		
	sts L+1,r14		;save L to RAM
	sts L+2,r15
	sts L+3,r16
	ret
;*******************
;----calc Q=X/R----*
;*******************
calcQ:
	ldi zl,low(R)
	ldi zh,high(R)
	rcall ld_z		;R-acc1
	rcall swapacc	;R-acc2
	ldi zl,low(jX)
	ldi zh,high(jX)
	rcall ld_z		;X-acc1	
	rcall fdiv		;Q-acc1
	sts Q,r13		
	sts Q+1,r14		;save Q to RAM
	sts Q+2,r15
	sts Q+3,r16
	ret
;*******************
;----calc DF=1/Q---*
;*******************
calcDF:	
	ldi zl,low(jX)
	ldi zh,high(jX)
	rcall ld_z		;jX-acc1
	rcall swapacc	;jX-acc2
	ldi zl,low(R)
	ldi zh,high(R)
	rcall ld_z		;R-acc1	
	rcall fdiv		;DF-acc1
	sts DF,r13		
	sts DF+1,r14		;save DF to RAM
	sts DF+2,r15
	sts DF+3,r16
;	rcall fltbcd
	ret
;-----------------------------------------
;--get sum v(i)*cos(i) for 1st 1/2 period (0 to 11)
getsum_up:
	rcall ldv		;load value v(i) to *x
	rcall itof		;convert to float	
	rcall KTOAC2	;acc2=cos(i)
	rcall f_mul		;acc1=v(i)*cos(i)
	rcall ld_sum	;load sum from RAM
	rcall fadd		;acc1=sum(v[i]*cos[i])
	rcall st_sum	;save sum to RAM
	ret
;--the same, but for 2nd 1/2 period (12 to 19)
getsum_down:
	rcall ldv		;load value v(i) to *x
	rcall itof		;convert to float	
	rcall KTOAC2_	;acc2=cos(i)
	rcall f_mul		;acc1=v(i)*cos(i)
	rcall ld_sum	;load sum from RAM
	rcall fadd		;acc1=sum(v[i]*cos[i])
	rcall st_sum	;save sum to RAM
	ret
;-----------------------------------------
sum_ac1:
	rcall ld_sum	;sum->acc2
	rcall swapacc	;sum->acc1
	ret
;----load 2byte value *x for ITOF--
ldv:ld r14,x+		; here values from ADC
	ld r13,x+
	clr r15
	clr r16
	clr r17
	clr r23	
	ret
;----------------------------------
ld_z:
	ld r13,z+
	ld r14,z+
	ld r15,z+
	ld r16,z+
	ret
;----load sum from RAM-------------
ld_sum:
	lds r18,sum_adr
	lds r19,sum_adr+1
	lds r20,sum_adr+2
	lds r21,sum_adr+3	;load SUM->acc2
	ret
;----save sum to RAM from acc1 ----
st_sum:
	sts sum_adr,r13
	sts sum_adr+1,r14
	sts sum_adr+2,r15
	sts sum_adr+3,r16
	ret
;----------------------------------
clr_sum:
	clr r23
	sts sum_adr,r23
	sts sum_adr+1,r23
	sts sum_adr+2,r23
	sts sum_adr+3,r23
	ret 
;------r100 r1k must be (90...110)!!!-----
eecheck:
		ldi adrEE,k100ee
		rcall EEread
		sts r100,dataEE		;load to RAM k100
		ldi temp,90
		cp dataEE,temp
		brlt set100			;<90-set 100
		ldi temp,111
		cp dataEE,temp		;>110-set100
		brlt k100good
set100:	ldi dataEE,100
		sts r100,dataEE
		rcall EEwrite		;save in EEPROM
k100good:
		ldi adrEE,k100kee
		rcall EEread
		sts r1k,dataEE
		ldi temp,90
		cp dataEE,temp
		brlt set100k
		ldi temp,111
		cp dataEE,temp
		brlt k1kgood
set100k:ldi dataEE,100
		sts r1k,dataEE
		rcall EEwrite
k1kgood:ret
;----------------------------------
delay: 	push temp		;about 10mS with ints
		push temp1
		ldi temp,$ff
loop1:	ldi temp1,$ff
loop:	dec temp1
		brne loop
		dec temp
		brne loop1
		pop temp1
		pop temp
		ret

delay1:	rcall delay		;about 30 mS
		rcall delay
		rcall delay
		rcall delay
		ret
;** Constants used for decimal conversion **
I1E6:	.db	0x40,0x42,0x0f,0	;  1,000,000
I1E5:	.db	0xa0,0x86,0x01,0	;    100,000
I1E4:	.db	0x10,0x27,0x00,0	;     10,000
I1E3:	.db	0xe8,0x03,0x00,0	;      1,000
I1E2:	.db	0x64,0x00,0x00,0	;        100
I1E1:	.db	0x0a,0x00,0x00,0	;         10
;
;** IEEE format **
PI:		.db	0xdb,0x0f,0x49,0x40	; 3.1415927f
PI2:	.db	0xdb,0x0f,0xc9,0x40	; 6.2831854f
Kp1:	.db	0xCD,0xCC,0xCC,0x3D	; 0.1f
Kp5:	.db	0x00,0x00,0x00,0x3F	; 0.5f
K1:		.db	0x00,0x00,0x80,0x3F	; 1.0f
K10:	.db	0x00,0x00,0x20,0x41	;10.0f
K100:	.db	0x00,0x00,0xc8,0x42	;100.0f
K1000:	.db	0x00,0x00,0x7a,0x44	;1000.0f
K1E6:		.db 0x00,0x24,0x74,0x49
K1E7:		.db	0x80,0x96,0x18,0x4b
K1E8:		.db	0x20,0xbc,0xbe,0x4c
K999999p9: 	.db	0xfe,0x23,0x74,0x49	; 999999.9f
K9999999:  	.db	0x7f,0x96,0x18,0x4b	;9999999.0f
K40960:		.db 0x00,0x00,0x20,0x47	;40960=1024*40
_2pf100:	.db 0x63,0x14,0x1d,0x44	;2*PI*100Hz
_2pf1000:	.db 0x7b,0x59,0xc4,0x45	;2*PI*1000Hz
;--------COS (semiperiod)-----------------
t0:		.db $00,$00,$80,$3f	; 1.0000000
t1:		.db $6e,$78,$73,$3f	; 0.9510565
t2:		.db $bc,$1b,$4f,$3f	; 0.8090170
t3:		.db $18,$79,$16,$3f	; 0.5877852
t4:		.db $79,$37,$9e,$3e	; 0.3090170
t5:		.db $00,$00,$00,$00	; 0.0000000
t6:		.db $79,$37,$9e,$be	;-0.3090170
t7:		.db $18,$79,$16,$bf ;-0.5877852
t8:		.db $bc,$1b,$4f,$bf ;-0.8090170
t9:		.db $6e,$78,$73,$bf ;-0.9510565
t10:	.db $00,$00,$80,$bf	;-1.0000000

smode:	.db 'S','e','r','i','a','l',' ',' ',' '
pmode:	.db 'P','a','r','a','l','l','e','l',' '
fr1K:	.db ' ','1','K','H','z'
fr100:	.db '1','0','0','H','z'
blnk:	.db '*','*','*','*','*','*','*','*','*','*','*','*','*','*' 
.include "Fprout.inc"
.include "outlcd.inc"
.include "sinus.inc"
