;EE_i:;************EEPROM************************************
;			ldi yl,low(array_i)
;			ldi yh,high(array_i)
;			ldi adrEE,0
;next_data:	ld dataEE,y+
;			rcall EEwrite 
;			inc adrEE
;			cpi adrEE,80
;			brne next_data
;			ret
;***********************************************************			
;EE_u:		ldi yl,low(array_u)
;			ldi yh,high(array_u)
;			ldi adrEE,$50
;next_data1:	ld dataEE,y+
;			rcall EEwrite 
;			inc adrEE
;			cpi adrEE,$50+80
;			brne next_data1
;			ret
;***********************************************************
EEWrite:;	cli
			push temp
			sbic eecr,eepe;used r20(dataEE),r25(adrEE)
			rjmp EEwrite
			clr temp
			out eearh,temp			
			out eearl,adrEE
			out eedr,dataEE
			sbi eecr,eempe
			sbi eecr,eepe
			pop temp
		;	sei
			ret	

;------------------------------------------------------
EEread:	;	cli
			push temp 
			sbic eecr,eepe;used r20(dataEE),r25(adrEE)
			rjmp EEread
			clr temp
			out eearh,temp	
			out eearl,adrEE
			sbi eecr,eere
			in dataEE,eedr
			pop temp
	;		sei
			ret
;--------------------------------------
t1compare:
		push zl
		push zh
		push r0
		push temp				;temp store
		in temp,sreg
		push temp				;sreg store
		lds zl,pointer			;load pointer from RAM
		lds zh,pointer+1
		lds temp,numper			;load number of period
		dec temp				;dec period counter
		brne goout2 			;all periods over?NO-get out
		lds temp,freqRAM		;YES-reload period counter(5-1KHz,50-100HZ)
		sbiw zl,1       		;decrement data pointer
		cpi zl,low(datasin*2-1) ;is long period over?
		brne goout3				;NO - return
		ldi zl,low(datasin*2+19);YES - take the first sin value
		ldi zh,high(datasin*2+19)
goout3:	lpm						;take next value
goout1:	sts ocr1bl,r0			;and put it to PWM...
goout2:	sts numper,temp			;reload Nper
		pop temp
		out sreg,temp			; restore SREG
		pop temp				;and so long...
		pop r0
		sts pointer,zl			;reload pointers
		sts (pointer+1),zh
		pop zh
		pop zl
		reti
;--------------------------------------
_tim1_ovf:	push temp
		in temp,sreg
		push temp
		lds temp,numper
		cpi temp,$5				;it defines 1st meas. time
		brne next
measure:lds temp,flagsRAM
		sbrs temp,meas			;start=0-> not to start!get out!
		rjmp next
		ldi temp,(1<<adsc)+(1<<aden)+(1<<adps1)
		sts adcsra,temp			;start convertion
wait:	lds temp,adcsra		
		sbrs temp,adif
		rjmp wait				;wait for complete
		lds r2,adcl				;result->r3-r2
		lds r3,adch
		ldi temp,(1<<adif)
		sts adcsra,temp			;stop conversion
;----------collect the SUM---------------------	
		ld r4,x+				;r4-r5<- old sum(i)
		ld r5,x
		sbiw x,1				;restore present X
		add r5,r2				;sum(i)=sum(i)+present value
		adc r4,r3
		st x+,r4				;back to RAM
		st x+,r5
		cpi xh,high(array_Uend)
		brne next
		cpi xl,low(array_Uend)
		brne next 				;is array over?
		ldi xl,low(array_i)		;YES- take i=1
		ldi xh,high(array_i)
		dec counter				;period counter --
		brne next				;begin next period
		lds temp,flagsRAM		;all periods are over
		andi temp ,$fe			;flag start=0 -> stop!
		sts flagsRAM,temp
next:	pop temp
		out sreg,temp			;restore SREG
		pop temp
		reti
;=======right button "FREQ"====================
btn_r:	push xl
		push xh
		push zl
		push zh
		push temp
		in temp,sreg
		push temp
		push temp1
		ldi temp,10				;100 ms check
chkbut:	sbic pind,righbut				
		rjmp remain				;pressing isnt correct-goout
		rcall delay
		dec temp
		brne chkbut				;it pressed!
		clr temp
		out tcnt0,temp			;clr T0
		ldi temp,(1<<tov0)
		out tifr0,temp			;reset tov0
		ldi temp,(1<<cs00)+(1<<cs02)
		out tccr0b,temp			;start T0(CK/1024)
		clr temp1
rels:	sbic pind,righbut
		rjmp setfreq			;wait for release
		sbis tifr0,tov0
		rjmp rels				;if no ovflow T0, wait...
		ldi temp,(1<<tov0)
		out tifr0,temp			;res ovf T0 flag
		inc temp1
		ldi temp,200
		cp temp1,temp			;temp1-overflows counter
		brge rels				;wait 3 sec
		clr temp
		out tccr0b,temp			;stop T0
		rcall corr_const		; >3s->corr_const!
		rjmp remain				;and get out!
setfreq:lds temp,flagsRAM
		ldi temp1,0b00000010	;mask for freq flag
		eor temp,temp1			;invert 1st bit
		sts flagsRAM,temp		;and back to RAM
		sbrc temp,frqncy
		rjmp s1khz				;flag frqncy=1 ->1KHz
		cbi portd,frq			;clr pd6(frq)
		ldi temp,50				;100Hz
		rjmp begin
s1khz:	ldi temp,5				;1KHz
		sbi portd,frq 			;set pd6(frq)
begin:	sts freqRAM,temp		;save freq.set to RAM
remain:	pop temp1
		pop temp
		out sreg,temp			;back SREG
		pop temp				;and another ones...
		pop zh
		pop zl
		pop xh
		pop xl
		reti
;----left button "MODE"--------------------------
btn_l:	push temp
		in temp,sreg
		push temp
		push temp1
		ldi temp,10				;50 ms check
chkbu:	sbic pind,leftbut				
		rjmp remain1			;pressing isnt correct-goout
		rcall delay
		dec temp
		brne chkbu				;it pressed!
rls:	sbis pind,leftbut
		rjmp rls				;wait for release
		lds temp,flagsRAM
		ldi temp1,0b00001000	;mask for mode flag
		eor temp,temp1			;invert 3rd bit
		sts flagsRAM,temp		;return...
remain1:pop temp1
		pop temp
		out sreg,temp			;restore SREG
		pop temp
		reti
;------------------------------------------------
corr_const:
		;---Release the Right button!!---
		ldi xl,low(screen)
		ldi xh,high(screen)
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		rcall flstring
		ldi zl,low(rel_but*2)
		ldi zh,high(rel_but*2)
		rcall flstring
		ldi zl,low(the*2)
		ldi zh,high(the*2)
		rcall flstring
		ldi zl,low(buttn*2)
		ldi zh,high(buttn*2)
		rcall flstring
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		rcall flstring
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		rcall flstring
		rcall lcdout
rels1:	sbis pind,righbut
		rjmp rels1			;wait for release
		;--Constant1 correction-----
		ldi xl,low(screen)
		ldi xh,high(screen)
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		rcall flstring
		ldi zl,low(cnst1*2)
		ldi zh,high(cnst1*2)
		rcall flstring
		ldi zl,low(correc*2)
		ldi zh,high(correc*2)
		rcall flstring
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		rcall flstring
		ldi zl,low(plusminus*2)
		ldi zh,high(plusminus*2)
		rcall flstring
		ldi zl,low(arrows*2)
		ldi zh,high(arrows*2)
		rcall flstring
		lds temp,r100
		call wrconst
		rcall lcdout
		ldi xl,low(screen)
		ldi xh,high(screen)
		;----------
		clr temp
		out tcnt0,temp
		ldi temp,(1<<cs00)+(1<<cs02)
		out tccr0b,temp			;start T0(CK/1024)
		clr temp1
rels2:	sbis pind,righbut
		rjmp br_press			;wait for pressing R-button
		sbis pind,leftbut
		rjmp bl_press			;wait for pressing L-button
		sbis tifr0,tov0
		rjmp rels2				;if no ovflow T0, wait...
		ldi temp,(1<<tov0)
		out tifr0,temp			;res ovf T0 flag
		inc temp1
		cpi temp1,200			;temp1-overflows counter
		brge rels2				;wait 3 sec
		clr temp
		out tccr0b,temp			;stop T0
		rjmp notpress

bl_press:
		call delay1
		sbic pind,leftbut
		rjmp bulrel
		rjmp bl_press			;wait for release L-button
br_press:
		call delay1
		sbic pind,righbut
		rjmp burrel
		rjmp br_press			;wait for release R-button
bulrel:	call delay1
		lds temp,r100
		dec temp				;r100-1
		sts r100,temp
		rjmp rels1				;wait for next press				
burrel:	call delay1
		lds temp,r100
		inc temp				;r100+1
		sts r100,temp
		rjmp rels1				;wait for next press

notpress:
		ldi adrEE,k100ee
		lds dataEE,r100
		call EEwrite
		;--Constant1 saved-----
		ldi xl,low(screen)
		ldi xh,high(screen)
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		call flstring
		ldi zl,low(cnst1*2)
		ldi zh,high(cnst1*2)
		call flstring
		ldi zl,low(saved*2)
		ldi zh,high(saved*2)
		call flstring
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		call flstring
		ldi zl,low(plusminus*2)
		ldi zh,high(plusminus*2)
		call flstring
		ldi zl,low(arrows*2)
		ldi zh,high(arrows*2)
		call flstring
		lds temp,r100
		call wrconst
		call lcdout
		ldi xl,low(screen)
		ldi xh,high(screen)
		
		
		clr temp
		out tcnt0,temp
		ldi temp,(1<<cs00)+(1<<cs02)
		out tccr0b,temp			;start T0(CK/1024)
		clr temp1
rels3:	sbis tifr0,tov0
		rjmp rels3				;if no ovflow T0, wait...
		ldi temp,(1<<tov0)
		out tifr0,temp			;res ovf T0 flag
		inc temp1
		cpi temp1,250			;temp1-overflows counter
		brge rels3				;wait 3 sec
		clr temp
		out tccr0b,temp			;stop T0

;--Constant2 correction-----
c2corr:	ldi xl,low(screen)
		ldi xh,high(screen)
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		call flstring
		ldi zl,low(cnst2*2)
		ldi zh,high(cnst2*2)
		call flstring
		ldi zl,low(correc*2)
		ldi zh,high(correc*2)
		call flstring
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		call flstring
		ldi zl,low(plusminus*2)
		ldi zh,high(plusminus*2)
		call flstring
		ldi zl,low(arrows*2)
		ldi zh,high(arrows*2)
		call flstring
		lds temp,r1k
		call wrconst
		call lcdout
		ldi xl,low(screen)
		ldi xh,high(screen)		
		clr temp
		out tcnt0,temp
		ldi temp,(1<<cs00)+(1<<cs02)
		out tccr0b,temp			;start T0(CK/1024)
		clr temp1
rels4:	sbis pind,righbut
		rjmp br_press1			;wait for pressing R-button
		sbis pind,leftbut
		rjmp bl_press1			;wait for pressing L-button
		sbis tifr0,tov0
		rjmp rels4				;if no ovflow T0, wait...
		ldi temp,(1<<tov0)
		out tifr0,temp			;res ovf T0 flag
		inc temp1
		cpi temp1,200			;temp1-overflows counter
		brge rels4				;wait 3 sec
		clr temp
		out tccr0b,temp			;stop T0
		rjmp notpress1

bl_press1:
		call delay1
		sbic pind,leftbut
		rjmp bulrel1
		rjmp bl_press1			;wait for release L-button
br_press1:
		call delay1
		sbic pind,righbut
		rjmp burrel1
		rjmp br_press1			;wait for release R-button
bulrel1:call delay1
		lds temp,r1k
		dec temp				;r100-1
		sts r1k,temp
		rjmp c2corr				;wait for next press				
burrel1:call delay1
		lds temp,r1k
		inc temp				;r100+1
		sts r1k,temp
		rjmp c2corr				;wait for next press

notpress1:
		ldi adrEE,k100kee
		lds dataEE,r1k
		rcall EEwrite
		ldi xl,low(screen)
		ldi xh,high(screen)
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		call flstring
		ldi zl,low(cnst2*2)
		ldi zh,high(cnst2*2)
		call flstring
		ldi zl,low(saved*2)
		ldi zh,high(saved*2)
		call flstring
		ldi zl,low(clrstr*2)
		ldi zh,high(clrstr*2)
		call flstring
		ldi zl,low(plusminus*2)
		ldi zh,high(plusminus*2)
		call flstring
		ldi zl,low(arrows*2)
		ldi zh,high(arrows*2)
		call flstring
		lds temp,r1k
		call wrconst
		rcall lcdout
		ldi xl,low(screen)
		ldi xh,high(screen)
		
		clr temp
		out tcnt0,temp
		ldi temp,(1<<cs00)+(1<<cs02)
		out tccr0b,temp			;start T0(CK/1024)
		clr temp1
rels5:	sbis tifr0,tov0
		rjmp rels5				;if no ovflow T0, wait...
		ldi temp,(1<<tov0)
		out tifr0,temp			;res ovf T0 flag
		inc temp1
		cpi temp1,250			;temp1-overflows counter
		brge rels5				;wait 3 sec
		clr temp
		out tccr0b,temp
		ret
;---wr to screen const in asci from temp---
wrconst:
		clr r21
		clr r22			;r22-r21-r20 3symbols
		mov r20,temp
		dec r21
tt:		inc r21
		ldi temp,10
		sub r20,temp
		brcc tt
		add r20,temp 
		dec r22
tt1:	inc r22
		sub r21,temp
		brcc tt1
		add r21,temp
		ori r20,$30
		ori r21,$30
		ori r22,$30
		ldi yl,low(screen+61)
		ldi yh,high(screen+61)
		st y+,r22
		st y+,r21
		st y+,r20
		ret
		

datasin:
.db 134,129,121,111,100,89,79,71,66,60,66,71,79,89,100,111,121,129,134,135
rel_but:
.db ' ',' ',' ',' ','R','e','l','e','a','s','e',' ',' ',' '
the:
.db ' ',' ',' ',' ',' ',' ',' ','a',' ',' ',' ',' ',' ',' '
buttn:
.db ' ','r','i','g','h','t',' ','b','u','t','t','o','n','!'
cnst1:
.db ' ',' ','C','o','n','s','t','a','n','t',' ','1',' ',' '
cnst2:
.db ' ',' ','C','o','n','s','t','a','n','t',' ','2',' ',' '
correc:
.db ' ',' ','c','o','r','r','e','c','t','i','o','n',' ',' '
plusminus:
.db ' ','"','-','"',' ',' ',' ',' ',' ',' ','"','+','"',' '
arrows:
.db ' ',' ',$7d,' ',' ',' ',' ',' ',' ',' ',' ',$7d,' ',' '
clrstr:
.db ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '
saved:
.db 'h','a','s',' ','b','e','e','n',' ','s','a','v','e','d'
